<template>
  <div>
    <transition
      mode="in-out"
      enter-active-class="animated fadeIn _veryfast _delay-250ms"
      leave-active-class="animated fadeOut _veryfast"
    >
      <!-- Breadcrumb container -->
      <div
        v-if="items.length > 0"
        :class="{
          ...getElementCssClass('container'),
          ...getRootElementCSSClasses()
        }"
      >
        <!-- Breadcrumb item -->
        <div
          v-for="(breadcrumb, index) in items"
          :key="breadcrumb.text"
          :class="{
            ...getElementCssClass('item')
          }"
        >
          <!-- Nav link / muted text -->
          <div
            :class="{
              ...getElementCssClass('itemText')
            }"
          >
            <VLink
              v-if="breadcrumb.to"
              :to="breadcrumb.to"
            >
              {{ breadcrumb.text }}
            </VLink>
            <span v-else>{{ breadcrumb.text }}</span>
          </div>

          <!-- Separator -->
          <div
            :class="{
              ...getElementCssClass('separator'),
              // For the last item hide separator
              ...(index === (items.length - 1) ? { hidden: true } : {})
            }"
          >&rsaquo;</div><!-- eslint-disable-line -->

        </div>
      </div>
    </transition>
  </div>
</template>

<script>
// Mixins
import Variantable from '@/mixins/variantable'
import ExtractsCSSClasses from '@/mixins/extracts-css-classes'
// Component style
import Style from './style'

/**
 * Breadcrumb component
 */
export default {
  name: 'Breadcrumb',
  mixins: [
    Variantable,
    ExtractsCSSClasses
  ],
  props: {
    /**
     * Breadcrumb items
     */
    items: {
      type: Array,
      default () {
        return []
      }
    }
  },
  // Style for variantable
  style: Style
}
</script>
